// StrCalc - Evaler

#ifndef IG_MODULE_STRCALC_EVALER_AS
#define IG_MODULE_STRCALC_EVALER_AS

// Z
// @ vZX^bN̑ƂB
// @partial

#include "Mo/abdata/queue.as"
#include "Mo/abdata/stack.as"
#include "Mo/abdata/pair.as"
#include "Mo/abdata/unor.as"
#include "Mo/Dmath.as"

#include "MCAssoc.as"
#include "MCEnv.as"
#include "MCVar.as"
#include "MCFunc.as"
#include "MCBlock.as"

#include "MCVector.as"

#include "plugin_Vector.as"
#include "plugin_Tuple.as"
#include "plugin_Pair.as"
#include "plugin_Complex.as"

#module MCEvaler \
	minQueue, miEnv, \
	mStkCalc, mStkMode, mResult, mResVt, mExitMode, mExitVt, mExitValue, \
	mIdx, mNowType, mNowData, \
	mNestBlockLiteral, mStkBlockLiteral, \
	mStkTupleLiteral, mNestTuple, \
	mNestLoop, mStkLoop

#include "header_inner.as"

//------------------------------------------------
// \z
//------------------------------------------------
#deffunc evaler_New array self, int block, int iEnv
	newmod self, MCEvaler@, block, iEnv
	return
	
#modinit int block, int iEnv
	
	miEnv = iEnv
	block_GetQueue block, minQueue			// s
	
	mStkCalc   = new_stack(), new_stack()	// ZX^bN (value, valtype)
	mResult    = 0							// Ԓl
	mResVt     = Valtype_Assoc				// Ԓl^
	mExitMode  = ExitMode_None				// I[h
;	mExitValue = 0
;	mExitVt    = 0
	mStkMode   = new_stack()				// [hX^bN
	
	evaler_BeginMode thismod, RunMode_End	// (ԕ)
	
	mIdx = 0
	
	mNestBlockLiteral = -1 : Stack_new mStkBlockLiteral
	mNestTupleLiteral = -1 : Stack_new mStkTupleLiteral
	mNestLoop         = -1 : Stack_new mStkLoop
	
	dbgout "\nEvZ <" + Queue_size( minQueue(0) ) + ">"
	return
	
//------------------------------------------------
// j
//------------------------------------------------
#deffunc evaler_Delete var self
	delmod self
	return
	
#modterm
	foreach mStkCalc : Stack_delete mStkCalc(cnt) : loop
	
	;evaler_EndMode thismod
	Stack_delete mStkMode
	return
	
//------------------------------------------------
// 擾
//------------------------------------------------
#modcfunc evaler_Get var resVt
	resVt = mResVt
	return  mResult
	
#modcfunc evaler_GetAsRVal var resVt,  local result
	result = evaler_Get(thismod, resVt)
	evaler_ExpandValueAsRVal thismod, result, resVt		// EӒlWJ
	return result
	
#modcfunc evaler_GetEnv
	return miEnv
	
//------------------------------------------------
// s[h
//------------------------------------------------
#modfunc evaler_BeginMode int mode
	Stack_push mStkMode, mode
;	dbgout "[MODE::BEGIN] " + mode
	return
	
#modfunc evaler_EndMode
;	dbgout "[MODE::END] " + evaler_CurMode(thismod)
	Stack_remove mStkMode
	return
	
#modcfunc evaler_CurMode
	return Stack_peek( mStkMode )
	
//------------------------------------------------
// s邩
//------------------------------------------------
#modcfunc evaler_Next
	if ( stt_error != Error_None ) { return false }
	
	switch ( evaler_CurMode(thismod) )
		
		// ~
		case RunMode_End:
		case RunMode_Yield:
			return false
			
		// (s)
		case_if ( swthis != RunMode_Run )
			return true
			
		// 
		case_if ( Queue_size( minQueue(0) ) <= mIdx ):
			evaler_EndMode thismod
			return false
			
		// p
		default:
			return true
			
	swend
	
//------------------------------------------------
// ̎o
// 
// @ *LStep** ̍ŏɈ񂾂ĂׂB
//------------------------------------------------
#modfunc evaler_GetNextToken
	mNowData = Queue_peek( minQueue(0), mIdx )		// data
	mNowType = Queue_peek( minQueue(1), mIdx )		// Valtype_*
	mIdx ++
	return
	
//------------------------------------------------
// s
//------------------------------------------------
#modfunc evaler_Run
	if ( evaler_CurMode(thismod) == RunMode_Yield ) {
		evaler_EndMode thismod
	} else {
		evaler_BeginMode thismod, RunMode_Run		// ʏsJn
	}
	
	repeat
		if ( evaler_Next(thismod) ) {
			evaler_Step thismod
		} else {
			break
		}
	loop
	
	// G[
	if ( stt_error ) {
		mResVt = Valtype_Error
		
	// ԒlȂ
	} elsif ( Stack_empty( mStkCalc(0) ) ) {
	//	logmes "[Error] when sI\nvZX^bN̂߁AԒlȂB"
	//	stt_error = Error_NoResult
	//	mResVt    = Valtype_Error
		mResult = assocNull
		mResVt  = Valtype_Assoc
		
	// Ԓlݒ
	} else {
		mResult = evaler_PopAsResult( thismod, mResVt )
	}
	
	return
	
//------------------------------------------------
// s
//------------------------------------------------
#modfunc evaler_Step
	
;	dbgout "#" + cnt + ": ((mNowType, mNowData), mNestBlockLiteral) = ((" + mNowType + ", " + mNowData + "), " + mNestBlockLiteral + ")"
	
	switch ( Stack_peek(mStkMode) )
		case RunMode_End:
		case RunMode_Yield:
			return
			
		case RunMode_Run:      evaler_Step_Run      thismod : return
		case RunMode_LitBlock: evaler_Step_LitBlock thismod : return
		case RunMode_LoopDo:   evaler_Step_LoopDo   thismod : return
		case RunMode_LoopFor:  evaler_Step_LoopFor  thismod : return
		default:
			assert
	swend
	
	return
	
//**********************************************************
//        Xebvs
//**********************************************************
//------------------------------------------------
// (ʏ)
//------------------------------------------------
#modfunc evaler_Step_Run \
	local tmp, local resVt, local result
	
	// ̎o
	evaler_GetNextToken thismod
	
	switch ( mNowType )
		// l
		case_if ( Valtype_Ident <= swthis && swthis <= Valtype_RefArg ):
			PushToStack mStkCalc, mNowData, mNowType			// ̂܂܃X^bNɐς
			swbreak
			
		// L (Mark)
		case Valtype_Mark:
			switch ( mNowData )									// TkType_*
				case TkType_Omission:
					PushToStack mStkCalc, mNowData, mNowType
					swbreak
					
				// EYXg
				case TkType_ArrayL:
				case TkType_ArgL:
				case TkType_IndexL:
				case TkType_TupleL:
					PushToStack mStkCalc, TkType_ArrayL, Valtype_Mark	// Ï
					swbreak
					
				case TkType_ArgR:
				case TkType_IndexR:
					result = PopArrayLiteral( mStkCalc, miEnv, true )	// (true: XgƂĂ̓WJ)
					PushToStack mStkCalc, result, Valtype_Arglist
					swbreak
					
				// z񃊃e or le
				case TkType_ArrayR:
				case TkType_TupleR
					result = PopArrayLiteral( mStkCalc, miEnv )
					if ( swthis == TkType_TupleR ) { vector_BeTuple result }
					PushToStack mStkCalc, result, Valtype_Assoc
					swbreak
					
				// 򃊃e
				case TkType_BlockL:
					mNestBlockLiteral ++
					Stack_push mStkBlockLiteral, new_block( miEnv )		// V𐶐
					evaler_BeginMode thismod, RunMode_LitBlock			// [hJnu򃊃ev
					swbreak
					
			//	case TkType_BlockR:
					
				default: swbreak
			swend
			swbreak
			
		// Z
		case Valtype_OpUni:
			result = evaler_CallOpUni( thismod, mNowData, resVt )
			PushToStack mStkCalc, result, resVt
			swbreak
			
		case Valtype_OpBin:
			result = evaler_CallOpBin( thismod, mNowData, resVt )
			PushToStack mStkCalc, result, resVt
			swbreak
			
		case Valtype_OpPoly:
			result = PopTupleLiteral( mStkCalc, miEnv, abs(mNowData) )
			PushToStack mStkCalc, result, Valtype_Assoc
			swbreak
			
		default:
			logmes "[Error] when vZ { mIdx: " + (mIdx - 1) + ", mNowData: " + mNowData + ", mNowType: " + mNowType + " }"
			PutErrorMsg "ɂ蓾Ȃl≉Zq݂B"
	swend
	
	return
	
//------------------------------------------------
// 򃊃e\z
//------------------------------------------------
#modfunc evaler_Step_LitBlock  local tmp
	
	if ( mNestBlockLiteral < 0 ) { return }
	
	// ̎o
	evaler_GetNextToken thismod
	
	// @ tmp is block
	if ( mNowType == Valtype_Mark &&  mNowData == TkType_BlockR && mNestBlockLiteral == 0 ) {
		// eI (ŊO '}')
		tmp = Stack_pop( mStkBlockLiteral )
		PushToStack mStkCalc, tmp, Valtype_Block	// mStkCalc Ɏ򃊃eς
		mNestBlockLiteral --
		evaler_EndMode thismod						// [hIu򃊃ev
		
	} else {
		tmp = Stack_peek( mStkBlockLiteral )
		block_Push tmp, mNowData, mNowType
		if ( mNowType == Valtype_Mark ) {
			if ( mNowData == TkType_BlockL ) { mNestBlockLiteral ++ }	// i[܂
			if ( mNowData == TkType_BlockR ) { mNestBlockLiteral -- }	// i󂭂Ȃ
		}
	}
	
	return
	
//------------------------------------------------
// : do
//------------------------------------------------
#modfunc evaler_Step_LoopDo  local tmp, local evaler, local result, local resVt
;	if ( mNestLoop < 0 ) { return }
	
	tmp = Stack_peek(mStkLoop)		// pair(env, block)
	
	// s
	block_GetEvaler pair_getRhs(tmp), evaler, pair_getLhs(tmp)
	evaler_Run evaler
	
	switch ( evaler_GetExitMode(evaler) )
		// ʏI
		case ExitMode_None:
			result = evaler_GetAsRVal( evaler, resVt )
			if ( resVt != Valtype_Bool ) { logmes "when ֐s(do)\ndoubN bool ԂȂ΂ȂB" : PutError Error_NeedBool }
			
			if ( result != true ) {
				evaler_EndLoop thismod		// I (ԒĺAdo() ̎_ null  push Ă)
			}
			swbreak
			
		// f
		default:
			evaler_EndLoop thismod
			
			result = evaler_GetExitValue( evaler, resVt )
			
			// break do =>  do ̏I
			if and( swthis == ExitMode_Break, resVt == Valtype_Func, result == FuncValue(PlugIn_Syntax, Func_Syntax_Do) ) {
				return
			}
			
			evaler_SetExit thismod, swthis, result, resVt
			swbreak
	swend
	
	return
	
//------------------------------------------------
// : for
//------------------------------------------------
#modfunc evaler_Step_LoopFor  \
	local tmp, local iVar, local count, local block, local evaler, local result, local resVt
	
	tmp = Stack_peek(mStkLoop)
	
	// s
	block = unor_get(tmp, "block")
	block_GetEvaler block, evaler, unor_get(tmp, "iEnv")
	evaler_Run evaler
	
	switch ( evaler_GetExitMode(evaler) )
		// ʏI
		case ExitMode_None:
			// XV
			iVar  = unor_get(tmp, "iVar")		// JE^ϐ
			count = var_Get(iVar)				// sJEg
			
			// I
			if ( count + 1 >= unor_get(tmp, "fincnt") ) {
				evaler_EndLoop thismod						// 
			} else {
				var_Set iVar, (count + 1), Valtype_Int		// JE^ϐ ++
			}
			swbreak
			
		// f
		default:
			evaler_EndLoop thismod
			
			result = evaler_GetExitValue( evaler, resVt )
			
			// break for => ̔̏I
			if and( swthis == ExitMode_Break, resVt == Valtype_Func, result == FuncValue(PlugIn_Syntax, Func_Syntax_For) ) {
				return
			}
			
			evaler_SetExit thismod, swthis, result, resVt
			swbreak
	swend
	
	return
	
//------------------------------------------------
// I
//------------------------------------------------
#modfunc evaler_EndLoop
	mNestLoop --
	Stack_remove mStkLoop
	evaler_EndMode thismod		// I
	return
	
//**********************************************************
//        I[h
//**********************************************************
//------------------------------------------------
// 擾
//------------------------------------------------
#modcfunc evaler_GetExitMode
	return mExitMode
	
#modcfunc evaler_GetExitValue var resVt
	resVt = mExitVt
	return mExitValue
	
//------------------------------------------------
// ݒ
//------------------------------------------------
#modfunc evaler_SetExit@MCEvaler int mode, var result, int resVt
	mExitMode  = mode
	mExitVt    = resVt
	mExitValue = result
	dbgout "[SetExit] " + EnumString_ExitMode(mode) + " " + dbgpair(result, resVt)
	
	switch ( mode )
		case ExitMode_None:		// IȂ
			swbreak
			
		case ExitMode_Return:
			evaler_BeginMode thismod, RunMode_End	// sI
			PushToStack mStkCalc, result, resVt		// Ԓl
			swbreak
			
		case ExitMode_Yield:
			evaler_Yield thismod					// yield wo
			PushToStack mStkCalc, result, resVt		// Ԓl
			swbreak
			
		case ExitMode_Break:
			evaler_BeginMode thismod, RunMode_End
			PushToStack mStkCalc, assocNull, Valtype_Assoc	// Ԓl
			swbreak
			
		default: assert
	swend
	return
	
//------------------------------------------------
// yield 
//------------------------------------------------
#modfunc evaler_Yield
	dbgout "[yield]"
	evaler_BeginMode thismod, RunMode_Yield
	return
	
#modcfunc evaler_IsYielded
	return ( evaler_CurMode(thismod) == RunMode_Yield )
	
//------------------------------------------------
// I[hp
// 
// @ resVt, (result)  evaler ̕ԒlԂB
//------------------------------------------------
#modcfunc evaler_InheritExit@MCEvaler var evaler, var resVt,  local result
	
	switch ( evaler_GetExitMode(evaler) )
		case ExitMode_None:
			swbreak
			
		default:
			result = evaler_GetExitValue( evaler, resVt )
			evaler_SetExit thismod, swthis, result, resVt
			swbreak
	swend
	return evaler_Get(evaler, resVt)
	
//------------------------------------------------
// I[hP
//------------------------------------------------
#modfunc evaler_RemoveExit@MCEvaler
	if ( mExitMode != ExitMode_None ) {
		if ( mExitMode == ExitMode_Return || mExitMode == ExitMode_Yield ) {
			repeat 2 : Stack_remove mStkCalc(cnt) : loop		// Ԓlp̒lj
		}
		
		evaler_SetExit@MCEvaler thismod, ExitMode_None, stt_zero@, 0
		evaler_EndMode thismod		// End or Yield 
	}
	return
	
//**********************************************************
//        ̑
//**********************************************************
// @partial
#include "MCEvaler_call_op.as"		// ZqƂ̕򏈗
#include "MCEvaler_proc_op.as"		// Z
#include "MCEvaler_proc_func.as"	// ֐
#include "MCEvaler_others.as"		// ̑A⏕֐Q

#global

#endif
