// Klac - partial: proc op

// #partial MCEvaler

//##########################################################
//            Z
//##########################################################

//**********************************************************
//        PZ
//**********************************************************
//------------------------------------------------
// PZ::Zp, rbg(~)
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Arith int optype, var resVt, var val, var val_vt,  local result
	if ( not EnumRange_Valtype_Numeric(val_vt) ) { PutError Error_NeedInt }
	
	resVt = val_vt
	
	switch ( optype )
		// Ou
		xcase PrefixOp_Plus:  return val
		xcase PrefixOp_Minus: return (-val)
		xcase PrefixOp_Inv:   result = (1.0 / val) : resVt = Valtype_Double
		xcase PrefixOp_Exp:   result = expf(val)   : resVt = Valtype_Double
		xcase PrefixOp_Sqrt:  result = evaler_ProcOpUni_Arith_SqrtReal( thismod, resVt, val )
		xcase PrefixOp_Not:
			if ( val_vt != Valtype_Int ) { PutError Error_NeedInt }
			return (-1) ^ val
			
		// u
		xcase PostfixOp_Fact:    result = fact_f( val )         : resVt = Valtype_Double
		xcase PostfixOp_Percent: result = (double(val) / 100.0) : resVt = Valtype_Double
		xdefault:
			assert
	swend
	
	StrCalc_ArithCnvDown result, resVt
	return result
	
//------------------------------------------------
// PZ::_
// 
// @ operator ! (Neg) ̂݁B
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Log int optype, var resVt, var val, var val_vt
	if ( val_vt != Valtype_Bool ) { PutError Error_NeedBool }
	
	resVt = Valtype_Bool
	if ( val == indet ) { return indet }		// !indet == indet
	return (val == false)
	
//------------------------------------------------
// PZ::֐
// 
// @ ݂ (=> x)  (() => x) Ȃ̂ŌĂ΂ȂB
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Func int optype, var resVt, var val, var val_vt,  \
	local iFuncNew
	assert /*
	
	if ( val_vt != Valtype_Block ) { PutError Error_NeedBlock }
	
	// ֐̐ { body: , env: ̐, plugin: Userdef }
	StrCalc_DefFunc block_GetEnv(val), "", 0 : iFuncNew = stat
	func_SetBlock iFuncNew, val
	
	resVt = Valtype_Func
	return FuncValue( PlugIn_Userdef, iFuncNew )
	//*/
	
//------------------------------------------------
// PZ::l
//------------------------------------------------
#modcfunc evaler_ProcOpUni_TupleMake int optype, var resVt, var val, var val_vt, \
	local result
	
	if and( IsTuple(val, val_vt), not vector_IsExpanded(val) ) {
		// WJ tuple => null 
		result = val
		vector_PushBack result, assocNull, Valtype_Assoc
		
	} else {
		//  => ꂩ琬 tuple 𐶐
		result = new_tuple_bySingle( val, val_vt, miEnv )
	}
	
	resVt = Valtype_Assoc
	return result
	
//------------------------------------------------
// PZ::
// 
// @ Ou͕ϐAu͌̕ϐlԂB
// @prm val: iVar ̒l, val_vt == Valtype_Var (Ӓl)
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Assign int optype, var resVt, var val, int val_vt, \
	local tmp, local tmp_vt, local t
	
	tmp    = var_Get( val )				// ̕ϐl
	tmp_vt = var_GetType( val )
	
	if ( tmp_vt == Valtype_Int ) {
		switch ( optype )
			case PrefixOp_Inc:
			case PostfixOp_Inc: t =  1 : swbreak
			case PrefixOp_Dec:
			case PostfixOp_Dec: t = -1 : swbreak
		swend
		
		var_Set val, tmp + t, tmp_vt		// ϐlύX
		
	} elsif ( tmp_vt == Valtype_Assoc ) {
		tmp = evaler_ProcOpUni_Assoc( thismod, tmp, tmp_vt, optype )	// ++ ܂ -- s
		
	} else {
		PutError Error_NeedInt
	}
	
	resVt = tmp_vt
	return tmp
	
//------------------------------------------------
// PZ::򉉎Z
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Block int optype, var resVt, var val, int val_vt, \
	local tmp
	
	assert ( val_vt == Valtype_Block )
	
;	dbgout dbgpair(val, val_vt)
	block_New       tmp, miEnv
	block_PushBlock tmp, val
	block_Push      tmp, optype, Valtype_OpUni	// Zq
	resVt = Valtype_Block
	return tmp
	
//------------------------------------------------
// PZ::Az̉Z
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Assoc int thisAssoc, var resVt, int optype,  \
	local result
	
	// _
	if ( optype == PrefixOp_Neg ) {
		result = evaler_ProcOpUni_AssocCnv( thismod, thisAssoc, resVt, Valtype_Bool )	// bool Ɍ^ϊ
		return evaler_ProcOpUni_Log( thismod, optype, resVt, (result), (resVt) )
	}
	
	return evaler_ProcOp_Assoc_Impl( thismod, thisAssoc, resVt, OpFuncName( GetName_UniOp(optype) ), assocNull )
	
//------------------------------------------------
// PZ::lZ
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Tuple int thisAssoc, var resVt, int optype, \
	local result
	
	assert IsTuple(thisAssoc, Valtype_Assoc)
	result = new_tuple( miEnv )
	
	repeat vector_Size(thisAssoc)
		PushToStack mStkCalc, vector_Get(thisAssoc, cnt), Valtype_Var		// evfX^bNɐς
		vector_PushBack result, evaler_CallOpUni( thismod, optype, resVt ), resVt
	loop
	
	resVt = Valtype_Assoc
	return result
	
//**********************************************************
//        񍀉Z
//**********************************************************
//------------------------------------------------
// 񍀉Z::Zp
// 
// @ f蓾
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Arith int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  local result, local bComplex
	bComplex = IsComplex(lhs, lhs_vt), IsComplex(rhs, rhs_vt)
	
	// ^`FbN
	if ( not( (EnumRange_Valtype_Numeric(lhs_vt) || bComplex(0)) && (EnumRange_Valtype_Numeric(rhs_vt) || bComplex(1)) ) ) { PutErrorNeed(Valtype_Double) }
	
	// Zp^ϊ
	StrCalc_ArithCnv lhs, lhs_vt, rhs, rhs_vt
	
	if ( bComplex(0) || bComplex(1) ) {		// f => Az̉Z
		return evaler_ProcOpBin_Assoc( thismod, optype, lhs, resVt, rhs, rhs_vt )
	}
	
	// ZnZ
	if ( optype == BinOp_Div || optype == BinOp_Mod ) {
		// 0 ZG[̃`FbN
		if ( toIntIfCan(rhs) == 0 ) { PutError Error_DivBy0 }
	}
	
	resVt = lhs_vt
	
	switch ( optype )
		xcase BinOp_Add: result = (lhs + rhs)
		xcase BinOp_Sub: result = (lhs - rhs)
		xcase BinOp_Mul: result = (lhs * rhs)
		xcase BinOp_Div: result = (double(lhs) / rhs) : resVt = Valtype_Double
		xcase BinOp_Mod: result = (double(lhs) \ rhs) : resVt = Valtype_Double
		
		xcase BinOp_Pow:  result = evaler_ProcOpBin_Arith_PowReal ( thismod, resVt, lhs, rhs )
		xcase BinOp_Root: result = evaler_ProcOpBin_Arith_RootReal( thismod, resVt, lhs, rhs )
		
		xdefault:
			assert
	swend
	
	StrCalc_ArithCnvDown result, resVt
	return result
	
//------------------------------------------------
// 񍀉Z::֌W
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Relation int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  local result, local needtype
	
	needtype = which( optype == BinOp_Cmp, Valtype_Int, Valtype_Bool )
	resVt    = needtype		// 
	
	result = evaler_ProcOpBin_RelationImpl( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
	if ( stt_error ) { PutError }
	
	// Ԓl^`FbN
	if ( resVt != needtype ) { PutErrorMsg "֌WZ " + DecodeOp_Bin(optype) + " (" + GetName_BinOp(optype) + ") ̕Ԓl " + GetName_Valtype(needtype) + " ^ɌB\n" + DecodeEvalElem( resVt, result ) }
	
	return result
	
#modcfunc evaler_ProcOpBin_RelationImpl int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  local bArith
	resVt = which( (optype == BinOp_Cmp), Valtype_Int, Valtype_Bool )
	
	// Aẑ̎QƓl
	if ( EnumRange_BinOp_RelRf(optype) ) {
		if ( lhs_vt == Valtype_Assoc && rhs_vt == Valtype_Assoc ) {
			resVt = Valtype_Bool
			return (lhs == rhs) ^ (optype == BinOp_NeRf)
		} else {
			PutError Error_NeedAssoc
		}
	}
	
	// Az̉Z
	if ( lhs_vt == Valtype_Assoc ) {
		return evaler_ProcOpBin_Assoc( thismod, optype, lhs, resVt, rhs, rhs_vt )
	}
	
	bArith(0) = (EnumRange_Valtype_Numeric(lhs_vt) || IsComplex(lhs, lhs_vt))	// Zp^ۂ
	bArith(1) = (EnumRange_Valtype_Numeric(rhs_vt) || IsComplex(rhs, rhs_vt))
	
	if ( EnumRange_BinOp_Cmp(optype) && not( (bArith(0) || lhs_vt == Valtype_Assoc) && bArith(1) ) ) {
		// 召֌W`ł͎̂Zp^ assoc Âǂ̌^łl֌W͔ł
		PutError Error_NeedInt
	}
	
	// ӂ̌^킹
	if ( lhs_vt != rhs_vt ) {
		// Zp^
		if ( bArith(0) || bArith(1) ) {
			StrCalc_ArithCnv lhs, lhs_vt, rhs, rhs_vt
			
			// Az̉Z(Complex)
			if ( lhs_vt == Valtype_Assoc ) {
				return evaler_ProcOpBin_Assoc( thismod, optype, lhs, resVt, rhs, rhs_vt )
			}
			
		// ̑ => ^sv
		} else {
			if ( optype == BinOp_Eq || optype == BinOp_Ne ) {
				return ( optype == BinOp_Ne )		// ^sv => Ne Ȃ^, Eq ȂU
			}
			PutErrorNeed( lhs_vt )
		}
	}
	
	return StrCalc_ProcOpBin_Relation_Impl( optype, lhs, rhs )
	
#defcfunc StrCalc_ProcOpBin_Relation_Impl int optype, var lhs, var rhs
	switch ( optype )
		case BinOp_Eq:   return (lhs == rhs)
		case BinOp_Ne:   return (lhs != rhs)
		
		case BinOp_Lt:   return (lhs <  rhs)
		case BinOp_Gt:   return (lhs >  rhs)
		case BinOp_LtEQ: return (lhs <= rhs)
		case BinOp_GtEQ: return (lhs >= rhs)
		
		case BinOp_Cmp:  return sgn(lhs - rhs)
	swend
	assert
	
//------------------------------------------------
// 񍀉Z::_ ()
// 
// @ <short> Log: rhs-Z (Eӂ͒Z)
// @ Eӂ̘Az̉Z(opBool)ōs
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Log int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt
	if ( lhs_vt != Valtype_Bool ) { PutError Error_NeedBool }
	assert ( rhs_vt == Valtype_Block )
	
	resVt = Valtype_Bool
	
	// Ș_Z̉
	;{
		if ( optype == BinOp_LogImp && lhs == false ) { return true  }
		if ( optype == BinOp_LogOr  && lhs == true  ) { return true  }
		if ( optype == BinOp_LogAnd && lhs == false ) { return false }
	;}
	
	// Z̓WJ
	;{
		rhs = evaler_ProcBlock( thismod, assocNull, (rhs), rhs_vt )		// ZWJ
		evaler_ExpandValueAsRVal thismod, rhs, rhs_vt
		
		if ( mExitMode != ExitMode_None ) { return indet }				// (rI) _~[lԋpĉZI
		if ( rhs_vt == Valtype_Block ) {
			return evaler_ProcOpBin_Block( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )	// 򉉎Z
		}
		
		if ( rhs_vt == Valtype_Assoc ) {		// bool ^֌^ϊ
			rhs = evaler_ProcOpUni_AssocCnv( thismod, (rhs), rhs_vt, Valtype_Bool )
		}
		if ( rhs_vt != Valtype_Bool ) { PutError Error_NeedBool }
	;}
	
	return StrCalc_ProcOpBin_Log_Impl( optype, lhs, rhs )
	
// _Z
#defcfunc StrCalc_ProcOpBin_Log_Impl int optype, int lhs, int rhs
	
	// @ Ș_Z͏Ă̂ōlȂ
	
	// 3l_
	if ( lhs == indet || rhs == indet ) {
		if ( optype == BinOp_LogImp && (/*lhs == false ||*/ lhs == rhs  ) ) { return true }
		if ( optype == BinOp_LogOr  && (/*lhs == true  ||*/ rhs == true ) ) { return true  }
		if ( optype == BinOp_LogAnd && (/*lhs == false ||*/ rhs == false) ) { return false }
		if ( optype == BinOp_LogXor && (lhs == rhs) ) { return false }
		return indet
	}
	
	// 2l_
	switch ( optype )
		case BinOp_LogImp: return (/*lhs == false ||*/ rhs != false)
		case BinOp_LogOr:  return (lhs || rhs)
		case BinOp_LogXor: return (lhs ^  rhs)
		case BinOp_LogAnd: return (lhs && rhs)
	swend
	
	assert
	
//------------------------------------------------
// 񍀉Z::rbg
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Bit int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt
	if ( lhs_vt != Valtype_Int || rhs_vt != Valtype_Int ) {
		PutError Error_NeedInt
	}
	resVt = Valtype_Int
	
	switch ( optype )
		case BinOp_BitAnd: return (lhs &  rhs)
		case BinOp_BitOr:  return (lhs |  rhs)
		case BinOp_BitXor: return (lhs ^  rhs)
		case BinOp_ShiftL: return (lhs << rhs)
		case BinOp_ShiftR: return (lhs >> rhs)
	swend
	
	assert
	
//------------------------------------------------
// 񍀉Z::Az (Az)
//------------------------------------------------
#modcfunc evaler_ProcOpBin_AssocOrAssocBind int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt, \
	local result, \
	local arglist, local body
	
	if ( rhs_vt != Valtype_Ident ) { PutError Error_NeedIdent }
	
	// (assoc).ident
	if ( lhs_vt == Valtype_Assoc ) {
		
		// oϐ̎o
		result = assoc_Find( lhs, rhs )
		resVt  = Valtype_Var
		
		if ( result < 0 ) {				// ݂Ȃʎq => ϐ𐶐
			if ( lhs == assocNull ) {	// null Q
				logmes "[Error] when 񍀉Z(Az)\nʂہI"
				PutErrorMsg "KbI"
			}
			
			assoc_DefVar lhs, rhs
			result = stat
		}
		
		// vpeB
		if ( var_GetType(result) == Valtype_Propaty ) {
			resVt  = Valtype_Propaty
			body   = pair_getRhs( var_Get(result) )		// vpeBAz
			result = new_pair( lhs, body )				// thisϐ𑩔vpeB𐶐
		;	pair_setLhs var_Get(result), lhs			// vpeB this 𑩔
		}
		
	// (func).ident
	} elsif ( lhs_vt == Valtype_Func ) {
		switch ( rhs )
		;	case "body_string":  result = func_GetBodyAsString(FuncId(lhs)) : resVt = Valtype_String : swbreak
			case "call":  result = Func_System_Call  : resVt = Valtype_Func : swbreak
			case "apply": result = Func_System_Apply : resVt = Valtype_Func : swbreak
			case "index": result = Func_System_Index : resVt = Valtype_Func : swbreak
			case "bind":  result = Func_System_Bind  : resVt = Valtype_Func : swbreak
			case "new":   result = Func_System_New   : resVt = Valtype_Func : swbreak
			
			case "name":  result = func_GetName(FuncId(lhs))    : resVt = Valtype_String : swbreak
			case "arity": result = func_GetCntPrms(FuncId(lhs)) : resVt = Valtype_Int    : swbreak
			default:
				PutErrorMsg "֐^̓o " + swthis + " ȂB"
		swend
		
	// (method).ident
	} elsif ( lhs_vt == Valtype_Method ) {
		switch ( rhs )
			case "this": result = pair_getLhs(lhs) : resVt = Valtype_Assoc : swbreak
			case "proc": result = pair_getRhs(lhs) : resVt = Valtype_Func  : swbreak
			default:
				PutErrorMsg "\bh^̓o " + swthis + " ȂB"
		swend
		
		if ( optype == BinOp_AssocBind ) { PutErrorMsg "\bh^͑Az(->)łȂB" }
		
	} else { PutError Error_NeedAssoc }
	
	// Az : result(\bh)  lhs() 𑩔
	if ( optype == BinOp_AssocBind ) {
		rhs = var_GetValue( result, rhs_vt )	// oϐ̒go
		
		return evaler_ProcFuncSystem_Bind( thismod, resVt, rhs, rhs_vt, lhs, lhs_vt )
	}
	
	return result
	
//------------------------------------------------
// 񍀉Z::ϊ ()
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Trans var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  \
	local result, local arglist
	
	// ֐|\bh => PĂяo
	if ( lhs_vt == Valtype_Func || lhs_vt == Valtype_Method ) {
		if ( IsTuple(rhs, rhs_vt) ) { goto *LProcBinOp_Trans_Tuple }	// lZ (ȅꍇ̂)
		
		// Xg𐶐
		arglist = new_vector( miEnv )	// arglist := [ rhs ]
		vector_PushBack arglist, rhs, rhs_vt
		
		// ֐Ăяo ( )
		return evaler_CallOpUni_List( thismod, PostfixOp_Call, resVt, lhs, lhs_vt, arglist )
	}
	
	evaler_ExpandValueAsRVal thismod, rhs, rhs_vt
	
	// l
	:*LProcBinOp_Trans_Tuple
	if ( evaler_ProcOpBin_TryTuple( thismod, BinOp_Trans, resVt, result, lhs, lhs_vt, rhs, rhs_vt ) ) {
		return result
	}
	
	// Az
	if ( lhs_vt == Valtype_Assoc ) {
		return evaler_ProcOpBin_Assoc( thismod, BinOp_Trans, lhs, resVt, rhs, rhs_vt )
	}
	
	// 򉉎Z (Z)
	if ( lhs_vt == Valtype_Block || rhs_vt == Valtype_Block ) {
		return evaler_ProcOpBin_Block( thismod, BinOp_Mul, resVt, lhs, lhs_vt, rhs, rhs_vt )
	}
	
	// ̑ => Z
	return evaler_ProcOpBin_Arith( thismod, BinOp_Mul, resVt, lhs, lhs_vt, rhs, rhs_vt )
	
//------------------------------------------------
// 񍀉Z::A
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Belong int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt, \
	local tmp
	
	resVt = Valtype_Bool
	
	// rhs: Type-func
	if ( rhs_vt == Valtype_Func && PluginId(rhs) == PlugIn_Type ) {
		rhs_vt = TypeFuncToValtype( FuncId(rhs) )	// Type-func ɑΉ^
		return ( lhs_vt == rhs_vt )
		
	// rhs: assoc
	} elsif ( rhs_vt == Valtype_Assoc ) {
		// instanceof
		if ( lhs_vt == Valtype_Assoc ) {
			if ( lhs == assocNull ) { return false }
			tmp = assoc_InstOf(lhs, rhs)		// prototype-chain 
			if ( tmp == true ) { return true }
		}
		
		// Az̉Z (rhs: this, lhs: )
		tmp = evaler_ProcOpBin_AssocByName( thismod, rhs, resVt, OpFuncName("Belong"), lhs, lhs_vt )
		if ( resVt != Valtype_Bool ) { PutErrorMsg "Z֐ .OpBelong  bool ^̒l̂ݕԋpłB" }
		return tmp
		
	} else {
		PutErrorMsg "<: ̉Eӂ͘Aẑ Type ֐Ɍ"
	}
	return
	
//------------------------------------------------
// 񍀉Z::_
// 
// @prm lhs: null or ʎq or ʎqXg  Xg
// @prm rhs: rhs-ZɎw肳Ă̂ŁAɎB
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Lambda int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt, \
	local prms, local cntPrms, local iVar, local iFuncNew
	
	assert ( rhs_vt == Valtype_Block )
	
	if ( lhs_vt == Valtype_Ident ) {
		cntPrms = 1
		prms    = lhs
		
	} elsif ( lhs_vt == Valtype_Assoc ) {
		// null => Ȃ
		if ( lhs == assocNull ) {
			cntPrms = 0				// null => Ȃ
			
		// vector => Xg (ʎqXg)
		} else {
			if ( not assoc_InstOf(lhs, stt_assoc_vector) ) { PutError Error_NeedVector }
			cntPrms = vector_Size(lhs)
			sdim prms, , cntPrms
			repeat cntPrms
				iVar = vector_Get(lhs, cnt)
				if ( var_GetType(iVar) != Valtype_Ident ) { PutErrorImpl Error_NeedIdent : break }
				prms(cnt) = var_Get(iVar)
			loop
			if ( stt_error ) { PutError }
		}
	}
	
	// ֐̐ { prms: `ʎqXg, body: , env: ̐, plugin: Userdef }
	StrCalc_DefFunc block_GetEnv(rhs), "", cntPrms : iFuncNew = stat
	func_SetBlock iFuncNew, rhs
	if ( cntPrms > 0 ) {
		func_SetPrmlist iFuncNew, prms
	}
	
	resVt = Valtype_Func
	return FuncValue( PlugIn_Userdef, iFuncNew )
	
//------------------------------------------------
// 񍀉Z::, Null ()
// 
// @ Z򂾂炯Ȃ̂Œ
// @	a ? ({ b } : { c })		# EӁF(pair)
// @	a ?  { b }				# EӁF
// @	a ?? { b }				# EӁF
//------------------------------------------------
#modcfunc evaler_ProcOpBin_WhichOrNullOr int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  local result, local bShorten
	
	// ӂ => 򉉎Z
	if ( lhs_vt == Valtype_Block ) {
		return evaler_ProcOpBin_Block( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
	}
	
	// ??
	if ( optype == BinOp_NullOr ) {
		if ( lhs_vt == Valtype_Assoc && lhs == assocNull ) {
			result = rhs : resVt = rhs_vt		// ӂ null => EӂԂ
			bShorten = true						// <short> NullOr: rhs-Z (Eӂ͒Z)
		} else {
			result = lhs : resVt = lhs_vt
		}
		
	// ?
	} else /* : if ( optype == BinOp_Which ) */ {
		if ( lhs_vt == Valtype_Assoc ) {
			lhs = evaler_ProcOpUni_AssocCnv( thismod, (lhs), lhs_vt, Valtype_Bool )	// ToBool()
		}
		if ( lhs_vt != Valtype_Bool  ) { PutError Error_NeedBool }
		
		if ( rhs_vt == Valtype_Block ) {		// EӁF
			if ( lhs == true ) {
				result = rhs : resVt = Valtype_Block
				bShorten = true					// <short> Which: rhs-Z (Eӂ͒Z)
			} else {
				result = assocNull : resVt = Valtype_Assoc
			}
			
		} else {								// EӁF(pair)
			if ( rhs_vt != Valtype_Assoc ) { PutError Error_NeedPair }
			if ( assoc_GetPrototypeAssoc(rhs) != stt_assoc_pair ) { PutError Error_NeedPair }
			
			result = var_GetValue( assoc_Find( rhs, which((lhs == true), "lhs", "rhs") ), resVt )	// ӂ^ => ӂԂ
			bShorten = true						// <short> Which(?:): then-, else-Z (΂ lhs, rhs ͂ǂZ)
		}
	}
	
	// Z => sĂԂ
	if ( bShorten ) {
		result = evaler_ProcBlock( thismod, assocNull, (result), resVt )
		
		// break(cond) => ? ZI邾
		if ( mExitMode == ExitMode_Break && mExitVt == Valtype_Func && mExitValue == FuncValue(PlugIn_System, Func_System_Cond) ) {
			evaler_RemoveExit thismod	// exit-mode P
		}
	}
	
	return result
	
//------------------------------------------------
// 񍀉Z::
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Pair int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  local result
	result = new_assoc( miEnv )
	resVt  = Valtype_Assoc
	
	assoc_DefVar result, "prototype", stt_assoc_pair, Valtype_Assoc
	assoc_DefVar result, "lhs", lhs, lhs_vt
	assoc_DefVar result, "rhs", rhs, rhs_vt
	
	return result
	
//------------------------------------------------
// 񍀉Z::l
// 
// @ WJԂŐB
// @ Eӂ null ̏ꍇ͒PZB
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Tuple var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  local result, local len
	
	// 
	if and( lhs_vt == Valtype_Assoc, lhs != assocNull, assoc_GetPrototypeAssoc(lhs) == stt_assoc_tuple, not vector_IsExpanded(lhs) ) {
		// WJ tuple => ̂܂ܕԒlɗp
		result = lhs
		
		len = vector_Size(result)
		if ( len == 1 ) {		// vf 1 Ȃ null } (  a, , b ƂȂĂ̂ )
			vector_PushBack result, assocNull, Valtype_Assoc
		}
		
	} else {
		//  => ӂ琬 tuple 𐶐
		result = new_tuple_bySingle( lhs, lhs_vt, miEnv )
	}
	
	if not( rhs_vt == Valtype_Assoc && rhs == assocNull ) {		// Eӂ null ȂAȂ
		vector_PushBack result, rhs, rhs_vt
	}
	
	resVt = Valtype_Assoc
	return result
	
//------------------------------------------------
// 񍀉Z::
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Swap var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt, \
	local result, local tmp, local tmp_vt
	
	result = rhs			// XEӂ̂Ԃ
	resVt  = rhs_vt
	
	if not( lhs_vt == Valtype_Var && rhs_vt == Valtype_Var ) { PutErrorMsg "Z <-> (Swap) ̗ӂ̓vpeBłȂӒlKvB" }
	
	// (l, ^) ̑g
	if ( lhs != rhs ) {		// QƓlȂȂ
		tmp = var_GetValue( lhs, tmp_vt )
		var_Set lhs, var_Get(rhs), var_GetType(rhs)
		var_Set rhs, tmp, tmp_vt
	}
	
	return result
	
//------------------------------------------------
// 񍀉ZFd, vector
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Assign_Vector int optype, var resVt, int dst, var src, var src_vt, \
	local lhs, local lhs_vt, \
	local rhs, local rhs_vt, \
	local bDual, local bSrcVector, local len
	
	if ( dst == assocNull ) { PutError Error_InvalidValue }
	
	bSrcVector = and( src_vt == Valtype_Assoc, src != assocNull, assoc_InstOf(src, stt_assoc_vector) )	// Eӂ vector
	
	if ( not assoc_InstOf(dst, stt_assoc_vector) ) {
		PutError Error_NeedVector			// vector łȂĂ͂ȂȂ
	}
	
	bDual = not vector_IsExpanded(dst)		// 悪AWJ => d, WJς => vector
	
	len = vector_Size(dst), which( bSrcVector, vector_Size(src), len(0) )
	repeat len(1)
		if ( len(0) <= cnt ) { break }		// (dst ̗vfȂ => ȏłȂ)
		
		if ( bSrcVector ) {
			rhs = var_GetValue( vector_Get(src, cnt), rhs_vt )		// l
		} else {
			rhs = src : rhs_vt = src_vt
		}
		
		// d => ӂ̗vf [cnt] Ӓlɑ
		if ( bDual ) {
			lhs = var_GetValue( vector_Get(dst, cnt), lhs_vt )		// ̎ʎq or ϐ
			if ( lhs_vt == Valtype_Assoc && lhs == assocNull ) { continue }		// lhs: null => Ȃ
			if ( not EnumRange_Valtype_Assignable(lhs_vt) ) { PutErrorImpl Error_NeedLeftValue }
			
		// vector => ӂ̗vf [cnt] ɑ
		} else {
			lhs = vector_Get(dst, cnt) : lhs_vt = Valtype_Var
		}
		
		_procfunc evaler_ProcOpBin_Assign( thismod, optype, resVt, lhs, lhs_vt, rhs, rhs_vt )
	loop
	
	// P => dst ̗]vf null  (ӂ [`, P] s邱Ƃۏ؂邽)
	//  => do_not
	if ( optype == BinOp_Set && len(0) > len(1) ) {
		rhs    = assocNull
		rhs_vt = Valtype_Assoc
		repeat len(0) - len(1), len(1)
		lhs = var_GetValue( vector_Get(dst, cnt), lhs_vt )		// ̎ʎq or ϐ
			_procfunc evaler_ProcOpBin_Assign( thismod, BinOp_Set, resVt, lhs, lhs_vt, rhs, rhs_vt )
		loop
	}
	
	resVt = Valtype_Assoc
	return dst
	
//------------------------------------------------
// 񍀉Z:: ()
// 
// @ ӎʎq͖WĴ܂܁B
// @ ͓ꏈȂ̂łł͎sȂB
// @prm lhs : Ӓl
// @prm rhs : l (EӒl)
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Assign int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt
	
	if ( lhs_vt == Valtype_Ident ) {
		evaler_ExpandIdent thismod, lhs, lhs_vt,  (optype == BinOp_Set)		// := Ȃ疢`ʎqł`
	}
	
	;{
		// 
	;	if ( lhs_vt == Valtype_Block ) { 򉉎Z }
	;}
	
	assert EnumRange_Valtype_Assignable(lhs_vt)
	
	// vpeB
	if ( lhs_vt == Valtype_Propaty ) {
;		if ( optype != BinOp_Set ) { PutErrorMsg "vpeBւ̑ := ł̂ݍsB" }
		return evaler_ProcOpBin_Assign_ToPropaty( thismod, resVt, lhs, rhs, rhs_vt )
		
	// ϐ
	} else {
		var_Setv lhs, rhs, rhs_vt
		resVt = Valtype_Var
		return lhs
	}
	
// vpeBւ̑
#modcfunc evaler_ProcOpBin_Assign_ToPropaty var resVt, int lhs, var rhs, var rhs_vt, \
	local iVar, local setter, local setter_vt, local iEnvNxt, local arglist
	
	// s鎮(set)𓾂
	;{
		iVar = assoc_Find( pair_getRhs(lhs), "set" )
		if ( iVar < 0 ) { PutErrorMsg "set ̂ȂvpeBւ͏߂ȂB" }
		setter = var_GetValue( iVar, setter_vt )
		if ( not EnumRange_Valtype_Callable(setter_vt) ) { PutErrorMsg "set  callable ɌB" }
	;}
	
	// setter s (Ԓlsv)
	switch ( setter_vt )
		case Valtype_Block:
			// V
			env_New     iEnvNxt, block_GetEnv(setter)
			env_SetThis iEnvNxt, pair_getLhs(lhs)							// propaty.lhs = (this-assoc)
			if ( setter_vt == Valtype_Block ) {
				assoc_DefVar env_GetAssoc(iEnvNxt), "value", rhs, rhs_vt	// ϐ value := (l) ǉ
			}
			_procfunc evaler_ProcBlockHere( setter, resVt, iEnvNxt )
			swbreak
			
		case Valtype_Func:
			arglist = new_vector( miEnv )			//  = [ rhs(value) ]
			vector_PushBack arglist, rhs, rhs_vt
			_procfunc evaler_CallFunc( thismod, resVt, pair_getLhs(lhs), setter, arglist )
			swbreak
	;	case Valtype_Assoc:
	;	case Valtype_Method:
	swend
	
	resVt = Valtype_Propaty
	return lhs			// vpeBԋp
	
//------------------------------------------------
// 񍀉Z::
//
// @ Êǂ炩A邢͗
// @ Zq rhs-Z ̏ꍇ́uӂ݂̂vƉ߂B
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Block int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  \
	local tmp
	
	tmp = new_block( miEnv )
	
	if ( lhs_vt == Valtype_Block && rhs_vt == Valtype_Block && not IsShortCircuitRhs(optype) ) {
			block_PushBlock tmp, lhs
			block_PushBlock tmp, rhs
	} else {
		if ( lhs_vt == Valtype_Block ) {
			block_PushBlock tmp, lhs
			block_Push      tmp, rhs, rhs_vt
		} else {
			block_Push      tmp, lhs, lhs_vt
			block_PushBlock tmp, rhs
		}
	}
	
	block_Push tmp, optype, Valtype_OpBin		// Zqǉ
	resVt = Valtype_Block
	return tmp
	
//------------------------------------------------
// 񍀉Z::Az̉Z
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Assoc int optype, int thisAssoc, var resVt, var rhs, var rhs_vt,  \
	local tmp
	
	// ֌W(<> ȊO) => opCmp()  0 ̔r
	if ( EnumRange_BinOp_Rel(optype) && optype != BinOp_Cmp ) {
		tmp = evaler_ProcOpBin_AssocByName( thismod, thisAssoc, resVt, OpFuncName("Cmp"), rhs, rhs_vt )
		evaler_ExpandValueAsRVal thismod, tmp, resVt
		
		if ( stt_error ) { PutError }
		if ( resVt != Valtype_Int ) { PutErrorMsg "Az̉Z֐ ." + OpFuncName("Cmp") + "  int ^̒l݂̂ԋpłB" }
		
		resVt = Valtype_Bool
		return StrCalc_ProcOpBin_Relation_Impl( optype, tmp, stt_zero@ )	// stt_zero@ == 0
		
	// _ => bool Ɍ^ϊĘ_Z
	} elsif ( EnumRange_BinOp_Log(optype) ) {
		dim tmp, 2			// [ bool-value, valtype ]
			tmp(0) = evaler_ProcOpUni_AssocCnv( thismod, thisAssoc, tmp(1), Valtype_Bool )
		
		return evaler_ProcOpBin_Log( thismod, optype, resVt, tmp(0), tmp(1), rhs, rhs_vt )
		
	// ̑
	} else {
		return evaler_ProcOpBin_AssocByName( thismod, thisAssoc, resVt, OpFuncName( GetName_BinOp(optype) ), rhs, rhs_vt )
	}
	
//------------------------------------------------
// 񍀉Z::lZ
// 
// @prm lhs, rhs : EӒl
// @prm mode:
// @	1: (rhs <: tuple)
// @	2: (lhs <: tuple)
//------------------------------------------------
#modcfunc  evaler_ProcOpBin_TryTuple int optype, var resVt, var result, var lhs, var lhs_vt, var rhs, var rhs_vt,  local bTuple
	bTuple = IsTuple(lhs, lhs_vt), IsTuple(rhs, rhs_vt)
	
	if ( bTuple(0) && bTuple(1) ) {
		result = evaler_ProcOpBin_TupleImpl( thismod, lhs, resVt, optype, rhs, rhs_vt, 3 )	//  (tuple, tuple)
	} elsif ( bTuple(0) ) {
		result = evaler_ProcOpBin_TupleImpl( thismod, lhs, resVt, optype, rhs, rhs_vt, 1 )	//  (tuple, single)
	} elsif ( bTuple(1) ) {
		result = evaler_ProcOpBin_TupleImpl( thismod, rhs, resVt, optype, lhs, lhs_vt, 2 )	// E (single, tuple)
	} else {
		return false
	}
	
	return true
	
#modcfunc evaler_ProcOpBin_TupleImpl int thisAssoc, var resVt, int optype, var val, var val_vt, int mode, \
	local result, local len, local idx
	
	if ( IsShortCircuitRhs(optype) ) { PutErrorMsg "rhs-ZZq " + DecodeOp_Bin(optype) + " ͑lZłȂB" }
	
	assert IsTuple(thisAssoc, Valtype_Assoc)	// this ͏ tuple (single * tuple ̏ꍇ tuple ͉Eӂ̂)
	result = new_tuple( miEnv )					// Ԓlp
	
	len = vector_Size(thisAssoc)
	
	repeat which( mode == 3, min(len, vector_Size(val)), len )		// ͒Zɍ킹
		idx = cnt
		
		// lhs, rhs ̏ɐς
		repeat 2
			if ( mode == 3 ) {				// ӂƂ tuple o
				PushToStack mStkCalc, vector_Get(what(cnt, thisAssoc, val), idx), Valtype_Var
				
			} elsif ( mode & (cnt + 1) ) {	// thisAssoc ɑΉ tuple A val Ŏ
				PushToStack mStkCalc, vector_Get(thisAssoc, idx), Valtype_Var		// evfX^bNɐς
				
			} else {
				PushToStack mStkCalc, val, val_vt
			}
		loop
		
		vector_PushBack result, evaler_CallOpBin( thismod, optype, resVt ), resVt
	loop
	
	resVt = Valtype_Assoc
	return result
	
//------------------------------------------------
// XgZ::lZ
// 
// @ evf̂ƂČĂяosB
//------------------------------------------------
#modcfunc evaler_ProcOpList_Tuple int thisAssoc, var resVt, int optype, int arglist,  local tmp, local tmp_vt, local result
	result = new_tuple( miEnv )
	
	repeat vector_Size(thisAssoc)
		tmp = var_GetValue( vector_Get(thisAssoc, cnt), tmp_vt )		// ϐWJĂ
		
		vector_PushBack result, evaler_CallOpUni_List( thismod, optype, resVt, tmp, tmp_vt, arglist ), resVt
	loop
	
	resVt = Valtype_Assoc
	return result
	
//**********************************************************
//        Az̉Z
//**********************************************************
//------------------------------------------------
// Az̉Z:: (by Z֐)
//------------------------------------------------
#modcfunc evaler_ProcOpBin_AssocByName int thisAssoc, var resVt, str name, var rhs, var rhs_vt,  \
	local arglist
	
	arglist = new_vector( miEnv )	// (arglist) := [ rhs ]
	vector_PushBack arglist, rhs, rhs_vt
	
	return evaler_ProcOp_Assoc_Impl( thismod, thisAssoc, resVt, name, arglist )
	
//------------------------------------------------
// Az̉Z::^ϊ
//------------------------------------------------
#modcfunc evaler_ProcOpUni_AssocCnv int thisAssoc, var resVt, int valtype,  \
	local typename, local result
	
	typename = GetName_Valtype(valtype)		// ^
	result   = evaler_ProcOp_Assoc_Impl( thismod, thisAssoc, resVt, CnvFuncName(typename), assocNull )
	evaler_ExpandValueAsRVal thismod, result, resVt
	
	if ( stt_error ) { PutError }
	if ( resVt != valtype ) { PutErrorMsg "^ϊ֐ ." + CnvFuncName(typename) + "  " + typename + " ^̂ݕԋpłB" }
	return result
	
//------------------------------------------------
// Az̉Z (RA)
// 
// @ apply( thisAssoc.name, arglist )
//------------------------------------------------
#modcfunc evaler_ProcOp_Assoc_Impl int thisAssoc, var resVt, str name, int arglist,  \
	local tmp, local tmp_vt, local evaler
	
	tmp = assoc_Find( thisAssoc, name )		// Z֐o
	
	if ( tmp > 0 ) {
		tmp = var_GetValue(tmp, tmp_vt)		// tmp ϐWJ
		
		if ( tmp_vt == Valtype_Func || tmp_vt == Valtype_Method ) {
			return evaler_CallFunc( thismod, resVt, thisAssoc, (tmp), arglist )	// Z֐ŏ
			
		} elsif ( tmp_vt == Valtype_Block ) {
			return evaler_ProcBlock( thismod, thisAssoc, tmp, resVt )
			
		} ;elsif ( vt == Valtype_Assoc )
	}
	
	resVt = Valtype_Error
	PutErrorMsg "Aẑo֐ ." + name + " ȂB\n" + DecodeValue_Assoc(thisAssoc)
	
//**********************************************************
//        ZpZ ()
//**********************************************************
// @ Math n֐Ă΂

//------------------------------------------------
//  ()
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Arith_SqrtReal var resVt, double val
	if ( val < 0 ) {
		return evaler_ProcOpBin_Arith_PowReal(thismod, resVt, val, 0.5)		// (//x = x^/2)
	}
	resVt = Valtype_Double
	return sqrt(val)
	
//------------------------------------------------
// Rΐ ()
//------------------------------------------------
#modcfunc evaler_ProcOpUni_Arith_LnReal var resVt, double val
	return evaler_ProcOpBin_Arith_LogReal(thismod, resVt, M_E, val)		// (ln x = log[e](x))
	
//------------------------------------------------
// p ()
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Arith_PowReal var resVt, double lhs, double rhs,  local result
	
	// fȂ (ꂪ, w񐮐)
	if ( lhs < 0 && not IsDoubleInt(rhs) ) {
		result = new_complex_real( lhs, miEnv )
		
		complex_PowWithReal result, rhs
		resVt = Valtype_Assoc
		
	// ŕ
	} else {
		if ( lhs == 0 || rhs == 0 ) {
			resVt = Valtype_Int
			return which( rhs == 0, 1, 0 )	// 0^0 = 1, x^0 = 1, 0^x = 0
		}
		
		result = powf( lhs, rhs )
		resVt = Valtype_Double
	}
	return result
	
//------------------------------------------------
// p ()
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Arith_RootReal var resVt, double lhs, double rhs
	// a//b  b^(/a)
	
	if ( lhs == 0 ) {
		dbgout "[Error] 0捪݂͑ȂB0//x = x^(1/0) Ȃ̂0ZG[B"
		PutError Error_DivBy0
	}
	
	return evaler_ProcOpBin_Arith_PowReal(thismod, resVt, rhs, 1.0 / lhs)
	
//------------------------------------------------
// ΐ ()
// 
// @ ZqƂĂ͖
//------------------------------------------------
#modcfunc evaler_ProcOpBin_Arith_LogReal var resVt, double lhs, double rhs
	// log[a]( b )
	
	if ( lhs < 0 || lhs == 1 ) { PutErrorMsg "ΐ̒1łȂ̐ɌB\n" + lhs }
	if ( rhs <= 0 )            { PutErrorMsg "ΐ̐^͐̐ɌB\n" + rhs }
	
	resVt = Valtype_Double
	return logf(rhs) / logf(lhs)
	
//**********************************************************
//        ̑
//**********************************************************
//------------------------------------------------
// Zp^̏ʕϊ
// 
// @ EȂ炻̂܂܁AقȂȂʂ̂̂ɕϊ
//------------------------------------------------
#deffunc StrCalc_ArithCnv var lhs, var lhs_vt, var rhs, var rhs_vt
	
	if ( lhs_vt == rhs_vt ) {
		//
		
	// (int, double) -> (double, double)
	} elsif ( lhs_vt == Valtype_Int && rhs_vt == Valtype_Double ) {
		lhs    = double(lhs)
		lhs_vt = Valtype_Double
		
	// (double, int) -> (double, double)
	} elsif ( lhs_vt == Valtype_Double && rhs_vt == Valtype_Int ) {
		rhs    = double(rhs)
		rhs_vt = Valtype_Double
		
	// (int,    complex) -> (complex, complex)
	// (double, complex) -> (complex, complex)
	} elsif ( (lhs_vt == Valtype_Int || lhs_vt == Valtype_Double) && rhs_vt == Valtype_Assoc ) {
		lhs    = new_complex_real( lhs, complex_GetEnv(rhs_vt) )
		lhs_vt = Valtype_Assoc
		
	// (complex, int)    -> (complex, complex)
	// (complex, double) -> (complex, complex)
	} elsif ( lhs_vt == Valtype_Int && (rhs_vt == Valtype_Double || rhs_vt == Valtype_Int) ) {
		rhs    = new_complex_real( rhs, complex_GetEnv(rhs_vt) )
		rhs_vt = Valtype_Assoc
	}
	
	return
	
//------------------------------------------------
// Zp^̉ʕϊ
// 
// @ \Ȍ艺ʂ̌^ɕϊB
//------------------------------------------------
#deffunc StrCalc_ArithCnvDown var val, var val_vt
	
	assert or( val_vt != Valtype_Assoc, IsComplex(val, val_vt) )
	
	switch ( val_vt )
		case Valtype_Assoc:
			val = complex_CnvDown(val, val_vt)
			swbreak
			
		case Valtype_Double:
			if ( IsDoubleInt(val) ) {
				val = int(val)
				val_vt = Valtype_Int
			}
			swbreak
	;	case Valtype_Int: swbreak
	swend
	return
	
//------------------------------------------------
// Zq argc
//------------------------------------------------
#defcfunc StrCalc_OperatorArgc int optype
	if ( optype < PostfixOp_Max ) {
		return which( EnumRange_UniOp_List(optype), -1, 1 )			// XgZȂ疳
	} else {
		return 2
	}
	