// Klac - in header

#ifndef IG_MODULE_KLAC_INNER_HEADER_AS
#define IG_MODULE_KLAC_INNER_HEADER_AS

#include "header.as"

#ifdef _DEBUG
		#define _MODE_KLAC_DEBUG_OUTPUT		// Oo͂邩ǂ
#endif
	
	#ifdef  _MODE_KLAC_DEBUG_OUTPUT
	 #define dbgout(%1 = "") logmes "" + (%1)
	#else
	 #define dbgout(%1 = "") :
	#endif
	
#define true  1
#define false 0
#define indet 2

#undef and
#undef or
#undef not
#define and short_and
#define or  short_or
#define not false ==

#define PutErrorImpl(%1 = stt_error)         stt_error = (%1) : logmes "[Error] " + StrCalc_GetErrorMessage() + " @[" + __HERE__ + "]" : assert
#define PutError(    %1 = stt_error, %2 = 0) PutErrorImpl %1 : return %2
#define PutErrorMsgImpl(%1)                  stt_error = Error_Msg : stt_error_msg = (%1) : logmes "[Error] " + stt_error_msg + " @[" + __HERE__ + "]" : assert
#define PutErrorMsg(    %1, %2 = 0)          PutErrorMsgImpl %1 : return %2
#define PutErrorArgc(%1)                     if (%1) { PutError Error_Argc }
#define PutErrorNeed(%1)                     PutError( Error_NeedValtype + (%1) )
#define PushToQueue(%1, %2, %3 = 0, %4 = "") Queue_push %1(0), %2 : Queue_push %1(1), %3 :; dbgout "que: %1 <- ( " + (%2) + ", " + (%3) + " )\t" + (%4)
#define PushToStack(%1, %2, %3 = 0, %4 = "") Stack_push %1(0), %2 : Stack_push %1(1), %3 :; dbgout "stk: %1 <- ( " + (%2) + ", " + (%3) + " )\t" + (%4)
#define elsif else : if

#define ctype ResultAndType(%1 = result, %2 = resVt, %3 = Valtype_Assoc) exprs( assign(%2, %3),  (%1) )

#define ctype FuncValue(%1, %2) MAKELONG(%2, %1)
#define ctype PluginId(%1)      HIWORD(%1)
#define ctype FuncId(%1)        LOWORD(%1)

#define ctype OpFuncName(%1)  ("op" + (%1))
#define ctype CnvFuncName(%1) ("to" + (%1))

#define ctype PairKeyOf(%1) which( (%1) == 0, "lhs", "rhs" )

// 
#define ctype IsRadixChar(%1)    eq_or( (%1), 'x', 'o', 'd', 'b', 't', 'v' )

// 2d˂ĉZqɂȂ镶
#define ctype IsDoubleOp(%1)     eq_or( (%1), '=', '+', '-', '/', '<', '>', '&', '|', '~', '?' )

// Zq̕
#define ctype IsPrefixOpStr(%1)   eq_or( (%1), "+", "-", "/", "^", "//", "~", "!", "=>", "++", "--" )
#define ctype IsNoBinOpStr(%1)    eq_or( (%1), "!", "++", "--" )				// 񍀉Zq

// EZq (BinOp_*)
#define ctype IsRightUnit(%1)    ( eq_or( (%1), BinOp_Pow, BinOp_Root, BinOp_Trans, BinOp_Which, BinOp_Pair, BinOp_Lambda ) || EnumRange_BinOp_Assign(%1) )

// ZZq
#define ctype IsShortCircuitRhs(%1) ( (%1) == BinOp_Which || (%1) == BinOp_NullOr || (%1) == BinOp_Lambda || EnumRange_BinOp_Log(%1) )	// rhs-Z

// uZqv^Cv
#define ctype IsOperatorType(%1) ( eq_or( (%1), TkType_Operator, TkType_BinOp, TkType_PrefixOp, TkType_PostfixOp, TkType_Comma ) || IsPolyOp(%1) )

// PZq
#define ctype IsUnaryOp(%1)      eq_or( (%1), TkType_PrefixOp, TkType_PostfixOp )

// Zq
#define ctype IsPolyOp(%1)       ( (%1) == TkType_PolyOp_Tuple )

// l^̃^Cv
#define ctype IsNumberType(%1)   eq_or( (%1), TkType_Int, TkType_Double )

// ulv^Cv
#define ctype IsValueType(%1)    ( IsNumberType(%1) || eq_or( (%1), TkType_Ident, TkType_String, TkType_Omission ) )

// 炪OɂƁAꂪlł悤ȃ^Cv
// @ ܂A̍ŌɂĂ悢
// @ l, E, uZq
#define ctype IsBefValueType(%1) ( IsValueType(%1) || IsBracketR(%1) || (%1) == TkType_PostfixOp )

// uʁv^Cv
#define ctype IsParenthesis(%1)  eq_or( (%1), TkType_ParenL, TkType_ParenR )
#define ctype IsBracketL(%1)     eq_or( (%1), TkType_ParenL, TkType_ArgL, TkType_BlockL, TkType_ArrayL, TkType_IndexL, TkType_TupleL )
#define ctype IsBracketR(%1)     eq_or( (%1), TkType_ParenR, TkType_ArgR, TkType_BlockR, TkType_ArrayR, TkType_IndexR, TkType_TupleR )
#define ctype IsBracket(%1)      ( IsBracketL(%1) || IsBracketR(%1) )

#define ctype IsExtraIdent(%1) ( ;false )

// l̎
;#define ctype IsNull(%1, %2)     ((%1) == assocNull && (%2) == Valtype_Assoc)
#define ctype IsOmission(%1, %2) (((%1) == TkType_Omission && (%2) == Valtype_Mark) || ((%1) == assocNull && (%2) == Valtype_Assoc))
#define ctype IsTuple(%1, %2)    and((%2) == Valtype_Assoc, (%1) != assocNull, assoc_GetPrototypeAssoc(%1) == stt_assoc_tuple)
#define ctype IsComplex(%1, %2)  and((%2) == Valtype_Assoc, (%1) != assocNull, assoc_InstOf(%1, stt_assoc_complex))

// 
;#define ctype rnd_unit (double(rnd(32768)) / 32768)

// 萔
#define STR_OMISSION "( )"
#define INFINITY logf@hsp(0)
#const  M_PI2 M_PI * 2

#enum HSPVAR_FLAG_DOUBLE = 3
#enum HSPVAR_FLAG_INT    = 4

// ÓILϐ
#define stt_lists      _stt_lists@mod_Klac

#define stt_env_global _stt_env_global@mod_Klac
#define stt_env_main   _stt_env_main@mod_Klac
#define stt_funclist   _stt_funclist@mod_Klac

#define stt_simple_evaler _stt_simple_evaler@mod_Klac

#define stt_assoc_vector  _stt_assoc_vector@mod_Klac
#define stt_assoc_tuple   _stt_assoc_tuple@mod_Klac
#define stt_assoc_pair    _stt_assoc_pair@mod_Klac
#define stt_assoc_complex _stt_assoc_complex@mod_Klac
#define stt_assoc_args    _stt_assoc_args@mod_Klac		// Xgp̕ϐ΂`邾̊

#define stt_error      _stt_error@mod_Klac
#define stt_error_msg  _stt_error_msg@mod_Klac

#endif
