// StrCalc Plugin - vector

#ifndef IG_STRCALC_PLUGIN_VECTOR_AS
#define IG_STRCALC_PLUGIN_VECTOR_AS

// Vector p̃vOC

#include "MCPlugin.as"
#include "MCVector.as"

#module _plg_vector

#include "header_inner.as"

//------------------------------------------------
// 
//------------------------------------------------
#deffunc PluginVector_Init
	
	// namespace Vector
	plugin_New stt_env_global, "Vector"
		plugin_vector = stat
		assoc_vector  = plugin_GetAssoc(plugin_vector)
		
	plugin_SetLabel plugin_vector, *LProcFunc
	
	// \bh
	plugin_DefFunc plugin_vector, "ctor",    0, true : func_vector_ctor    = stat
	plugin_DefFunc plugin_vector, "dup",     0, true : func_vector_dup     = stat
	plugin_DefFunc plugin_vector, "size",    0, true : func_vector_size    = stat
	plugin_DefFunc plugin_vector, "empty",   0, true : func_vector_empty   = stat
	plugin_DefFunc plugin_vector, "at",     -1, true : func_vector_at      = stat
	plugin_DefFunc plugin_vector, "peek",    1, true : func_vector_peek    = stat
	plugin_DefFunc plugin_vector, "find",    1, true : func_vector_find    = stat
	plugin_DefFunc plugin_vector, "insert",  2, true : func_vector_insert  = stat
	plugin_DefFunc plugin_vector, "chain",   1, true : func_vector_chain   = stat
	plugin_DefFunc plugin_vector, "push",    1, true : func_vector_push    = stat
	plugin_DefFunc plugin_vector, "remove",  1, true : func_vector_remove  = stat
	plugin_DefFunc plugin_vector, "pop",     0, true : func_vector_pop     = stat
	plugin_DefFunc plugin_vector, "setSize", 1, true : func_vector_setSize = stat
	plugin_DefFunc plugin_vector, "move",    2, true : func_vector_move    = stat
	plugin_DefFunc plugin_vector, "swap",    2, true : func_vector_swap    = stat
	plugin_DefFunc plugin_vector, "reverse", 0, true : func_vector_reverse = stat
	plugin_DefFunc plugin_vector, "slice",   2, true : func_vector_slice   = stat
	plugin_DefFunc plugin_vector, "pick",   -1, true : func_vector_pick    = stat
	plugin_DefFunc plugin_vector, "cat",     1, true : func_vector_cat     = stat
;	plugin_DefFunc plugin_vector, "each",    2, true : func_vector_each    = stat
	
	plugin_DefFunc plugin_vector, "toTuple",  0, true : func_vector_ToTuple  = stat
	
	// vpeB
	plugin_DefPropaty plugin_vector, "length", func_vector_size, func_vector_setSize
	
	// Z֐
;	plugin_DefFunc plugin_vector, "opCmp",    1, true : func_vector_OpCmp    = stat
	
	plugin_DefFunc plugin_vector, "opNot",    0, true : func_vector_opNot    = stat		// ~  ->slice()->reverse()
	plugin_DefFunc plugin_vector, "opBelong", 1, true : func_vector_opBelong = stat		// <:  ->find($) >= 0
;	plugin_DefFunc plugin_vector, "opMul",    1, true : func_vector_opMul    = stat		// * ()
	
	assoc_DefVar assoc_vector, "opBitOr", FuncValue( plugin_vector, func_vector_cat ), Valtype_Func		// ~   ->cat()
	assoc_DefVar assoc_vector, "opIndex", FuncValue( plugin_vector, func_vector_at  ), Valtype_Func		// []  ->at()
	
	return plugin_vector
	
//------------------------------------------------
// 
//------------------------------------------------
#define ctype SetResult(%1 = thisAssoc, %2 = Valtype_Assoc) result = (%1) : resVt = (%2)

#deffunc local _dummy_proc var lbProc, var thisEval, int thisAssoc, int iFunc, var result, var resVt, int arglist, int cntArgs, int iEnv,  \
	local tmp, local tmp_vt
	
*LProcFunc
	if ( thisAssoc == assocNull ) {
		PutError Error_InvalidValue
	}
	
	switch ( iFunc )
		case func_vector_ctor:
			vector_Ctor thisAssoc
			SetResult()
			swbreak
			
		case func_vector_dup:
			SetResult( vector_Dup(thisAssoc) )
			swbreak
			
		case func_vector_size:
			SetResult( vector_Size(thisAssoc), Valtype_Int )
			swbreak
			
		case func_vector_empty:
			SetResult( vector_Empty(thisAssoc), Valtype_Bool )
			swbreak
			
		case func_vector_at:
			SetResult( vector_EnIndex(thisAssoc, resVt, arglist, cntArgs), resVt )
			swbreak
			
		case func_vector_find:
			if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false )	// l
			result = vector_Find( thisAssoc, resVt, tmp, tmp_vt, iEnv )
			swbreak
			
		case func_vector_opBelong:
		;	if ( cntArgs != 1 ) { PutError Error_Argc }
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false )	// l
			result = vector_Find( thisAssoc, resVt, tmp, tmp_vt, iEnv ) >= 0
			resVt  = Valtype_Bool
			swbreak
			
		case func_vector_insert:
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 1, tmp_vt, false )
			vector_Insert thisAssoc, evaler_GetValueFromArglist( thisEval, arglist, 0, resVt, false, Valtype_Int ), tmp, tmp_vt
			SetResult()
			swbreak
			
		case func_vector_chain:
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false, Valtype_Assoc )
			if ( not assoc_InstOf(tmp, stt_assoc_vector) ) { PutError Error_NeedVector }
			vector_Chain thisAssoc, tmp
			SetResult()
			swbreak
			
		case func_vector_remove:
			vector_Remove thisAssoc, evaler_GetValueFromArglist( thisEval, arglist, 0, resVt, false, Valtype_Int )
			SetResult( stat, Valtype_Var )
			swbreak
			
		case func_vector_setSize:
			vector_SetSize thisAssoc, evaler_GetValueFromArglist( thisEval, arglist, 0, resVt, false, Valtype_Int )
			SetResult()
			swbreak
			
		case func_vector_push:
			if ( cntArgs == 0 ) { PutError Error_Argc }
			repeat cntArgs
				tmp = evaler_GetValueFromArglist( thisEval, arglist, cnt, tmp_vt, false )
				vector_PushBack thisAssoc, tmp, tmp_vt
			loop
			SetResult()
			swbreak
			
		case func_vector_pop:
			vector_PopBack thisAssoc
			SetResult( stat, Valtype_Var )
			swbreak
			
		case func_vector_peek:			// 납
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, resVt,  false, Valtype_Int )		// idx_back
			SetResult( vector_Get( thisAssoc, (vector_Size(thisAssoc) - 1) - tmp ), Valtype_Var )	// 납 tmp ̗vf
			swbreak
			
		case func_vector_move:
		case func_vector_swap:
			if ( swthis == func_vector_swap && vector_Size(thisAssoc) == 2 ) {	// swap ͒ 2 ̂Ƃȗł
				tmp = 0, 1
				
			} else {
				if ( cntArgs != 2 ) { PutError Error_Argc }
				repeat 2
					tmp(cnt) = evaler_GetValueFromArglist( thisEval, arglist, cnt, tmp_vt(cnt), false, Valtype_Int )
				loop
			}
			if ( iFunc == func_vector_move ) {
				vector_Move thisAssoc, tmp(0), tmp(1)
			} else {
				vector_Swap thisAssoc, tmp(0), tmp(1)
			}
			SetResult()
			swbreak
			
		case func_vector_reverse:
			dim tmp,    2
			dim tmp_vt, 2
			tmp(0) = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt(0), false, Valtype_Int, true )
			tmp(1) = evaler_GetValueFromArglist( thisEval, arglist, 1, tmp_vt(1), false, Valtype_Int, true )
			if ( IsOmission(tmp(0), tmp_vt(0)) ) { tmp(0) = 0                      /*: tmp_vt(0) = Valtype_Int */ }
			if ( IsOmission(tmp(1), tmp_vt(1)) ) { tmp(1) = vector_Size(thisAssoc) /*: tmp_vt(1) = Valtype_Int */ }
			
			vector_Reverse thisAssoc, tmp(0), tmp(1)
			SetResult()
			swbreak
			
	;	case func_vector_each:
			
		case func_vector_slice:		// ԃXCX
			if ( cntArgs > 2 ) { PutError Error_Argc }
			
			dim tmp,    2 + 3
			dim tmp_vt, 2
			tmp(0) = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt(0), false, Valtype_Int, true )
			tmp(1) = evaler_GetValueFromArglist( thisEval, arglist, 1, tmp_vt(1), false, Valtype_Int, true )
			if ( IsOmission(tmp(0), tmp_vt(0)) ) { tmp(0) = 0                      /*: tmp_vt(0) = Valtype_Int */ }
			if ( IsOmission(tmp(1), tmp_vt(1)) ) { tmp(1) = vector_Size(thisAssoc) /*: tmp_vt(1) = Valtype_Int */ }
			
			SetResult( vector_Slice(thisAssoc, tmp(0), tmp(1)) )
			swbreak
			
		case func_vector_pick:		// wXCX
			SetResult( vector_EnIndex_Pick( thisAssoc, resVt, arglist ) )
			swbreak
			
		case func_vector_cat:		// A
			if ( cntArgs != 1 ) { PutError Error_Argc }
			
			result = vector_Slice(thisAssoc)
			tmp    = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false, Valtype_Assoc )
			if ( not assoc_InstOf(tmp, stt_assoc_vector) ) { PutError Error_NeedVector }
			
			vector_Chain result, tmp
			SetResult( result )
			swbreak
			
		case func_vector_ToTuple:
			vector_BeTuple thisAssoc
			SetResult()
			swbreak
			
		case func_vector_opNot:
			tmp = vector_Slice(thisAssoc)
			vector_Reverse tmp
			SetResult( tmp )
			swbreak
			
	;	case func_vector_opMul:			// 
			/*
			repeat 2
				Queue_new tmp(cnt)		// [l, Valtype] : inQueue (s) ƂĎgp
			loop
			
			tmp(2) = vector_Size(tmp(0))
			tmp(3) = vector_Dup(thisAssoc)		// lhs
			tmp(4) = evaler_GetValueFromArglist( thisEval, arglist, 0, resVt, false, Valtype_Assoc )
			
			if ( tmp(2) != vector_Size(tmp(1)) ) { PutError Error_Argc }
			
			repeat tmp(2)
				tmp(5) = cnt
				repeat 2
					tmp(6 + cnt) = vector_Get(tmp(3 + cnt), tmp(5))
					PushToQueue tmp, var_Get(tmp(6 + cnt)), var_GetType(tmp(6 + cnt))
				loop
			loop
			SetResult( tmp )
			swbreak
			//*/
			
		default:
			assert
	swend
	return
	
*LMakeSlice
	// 
	
	return
	
#global

#endif
