// StrCalc - decode

#ifndef IG_MODULE_STRCALC_DECODE_AS
#define IG_MODULE_STRCALC_DECODE_AS

#include "Mo/abdata/queue.as"
#include "Mo/strutil.as"

#module mod_StrCalc_decode

#include "header_inner.as"

//------------------------------------------------
// g[N̕
// 
// @cnv: s  nR[h
// @ t|[hL@߂߁AX^bN(stkDec)pB
// 
// @ Valtype_Block  '{' ƂɂB
//------------------------------------------------
#deffunc StrCalc_Decode var result, array inQueue,  \
	local stkDec, local lenQueue, local nowType, local nowData, local resVt, \
	local lhs, local lhs_vt, local rhs, local rhs_vt, local tmp, local argc, local arglist, local nestBlock
	
	dbgout "\nE(decode)"
	
		#define ctype NextLine ("\n" + strmul("\t", nestBlock))
		#define ctype EnParen(%1) ("(" + (%1) + ")")
	
	lenQueue = Queue_size( inQueue )
	
	Stack_new stkDec(0)		// value
	Stack_new stkDec(1)		// valtype
	result = ""
	
	nestBlock = 0
	
	// sX^bNɐς
	repeat lenQueue
		
		// G[́AIɌvZI
	;	if ( stt_error ) { break }
		
		// ̃f[^o
		nowData = Queue_peek( inQueue(0), cnt )		// data
		nowType = Queue_peek( inQueue(1), cnt )		// Valtype
		
	;	dbgout "#" + cnt + ": (nowData, nowType) = (" + nowData + ", " + EnumString_Valtype(nowType) + ")"
		
		switch ( nowType )
			// l
			case Valtype_Ident:
			case Valtype_Int:
			case Valtype_Double:
			case Valtype_Bool:
			case Valtype_String:
			
			case Valtype_Assoc:
			case Valtype_Block:
				PushToStack stkDec, DecodeEvalElem(nowType, nowData), Valtype_Decoded
				swbreak
				
			case Valtype_Func:
				if ( func_IsInternal( FuncId(nowData) ) ) {		// gݍ݊֐͖̂AOvOCȂ炻̃vOCŏCāAԂ
					tmp = PluginId(nowData)
					PushToStack stkDec, which( tmp >= PlugIn_Outer, plugin_GetName(tmp) + ".", "" ) + func_GetName(FuncId(nowData)), Valtype_Decoded
					swbreak
				}
			//	fall-through
			case Valtype_Method:
				logmes "[this type(" + nowType + ") value(" + nowData + ") is unsupoprted to decode]"
				PushToStack stkDec, ("<" + EnumString_Valtype(nowType) + "|" + nowData + ">"), Valtype_Decoded
				swbreak
				
			// L
			case Valtype_Mark:
				switch ( nowData )
					case TkType_Omission:
						PushToStack stkDec, STR_OMISSION, Valtype_Decoded
						swbreak
						
					// 
					case TkType_ArgL:
					case TkType_IndexL:
					case TkType_ArrayL:
					case TkType_TupleL:
						PushToStack stkDec, TkType_ArrayL, Valtype_Mark			// XgÏ
						swbreak
						
					case TkType_ArgR:
					case TkType_IndexR:
					//	postfix op ŏ
						swbreak
						
					case TkType_ArrayR:
						tmp = PopAsListDecoded( stkDec, "[", "]" )
						PushToStack stkDec, tmp, Valtype_Decoded
						swbreak
						
					case TkType_TupleR:
						tmp = PopAsListDecoded( stkDec, "(", ")" )
						PushToStack stkDec, tmp, Valtype_Decoded
						swbreak
						
					// 򃊃e
					case TkType_BlockL:
						nestBlock ++
						PushToStack stkDec, "{", Valtype_Block
						swbreak
						
					case TkType_BlockR:
						if ( Stack_peek( stkDec(1) ) == Valtype_Decoded ) {
							Stack_remove stkDec(1)
							tmp = NextLine() + Stack_pop( stkDec(0) )
							nestBlock --
							tmp += NextLine()
						} else {
							tmp = ""
							nestBlock --
						}
						
						if ( Stack_peek( stkDec(1) ) == Valtype_Block ) {
							Stack_remove stkDec(1)
							Stack_remove stkDec(0)
							PushToStack stkDec, "{" + tmp + "}", Valtype_Decoded
						;	dbgout "push-block: {" + tmp + "}"
						} else {
						;	dbgout dbgpair( Stack_peek( stkDec(0) ), Stack_peek( stkDec(1) ) )
						;	Stack_dbglog stkDec(0)
						;	Stack_dbglog stkDec(1)
							assert
						}
						
						swbreak
						
				swend
				swbreak
				
			// Z
			case Valtype_OpUni:
				// prefix
				if ( nowData < PrefixOp_Max ) {
					tmp = DecodeOp_Uni(nowData)
					rhs = PopAsDecoded(stkDec)
				;	dbgout "[uni]" + dbgpair(tmp, rhs)
					PushToStack stkDec, EnParen(tmp + rhs), Valtype_Decoded
					
				// postfix
				} else {
					// XgZq
					if ( nowData == PostfixOp_Call || nowData == PostfixOp_Index ) {
						
						// Xg𓾂
						tmp = which( nowData == PostfixOp_Call, PopAsListDecoded( stkDec, "(", ")" ), PopAsListDecoded( stkDec, "[", "]" ) )
						
						// (֐q, Az)𓾂
						lhs = PopAsDecoded( stkDec )
						
						PushToStack stkDec, (lhs + tmp), Valtype_Decoded
						
					} else {
						lhs = PopAsDecoded(stkDec)
						tmp = DecodeOp_Uni(nowData)
					;	dbgout "[uni]" + dbgpair(lhs, tmp)
						PushToStack stkDec, EnParen(lhs + tmp), Valtype_Decoded
					}
				}
				swbreak
				
			case Valtype_OpBin:
				rhs = PopAsDecoded( stkDec )
				lhs = PopAsDecoded( stkDec )
			;	dbgout "[bin " + DecodeOp_Bin(nowData) + "] " + dbgpair(lhs, rhs)
				
				if ( nowData == BinOp_Split ) {
					tmp = lhs + ";" + NextLine() + rhs		// ';' ŉs
					
				} elsif ( nowData == BinOp_Tuple ) {
					tmp = EnParen( lhs + ", " + rhs )		// Zq(',')̉E󔒂
					
				} elsif ( nowData == BinOp_Trans ) {
					tmp = EnParen( lhs + " " + rhs )
					
				} elsif ( StrCalc_GetBinOpLevel(nowData) >= StrCalc_GetBinOpLevel(BinOp_Pow) ) {	// ͂ ^ ȏ
					tmp = EnParen( lhs + DecodeOp_Bin(nowData) + rhs )		// 󔒂Ȃ
					
				} else {
					// Z̉
					if ( IsShortCircuitRhs(nowData) && nowData != BinOp_Which ) {
						Decode_UnBlock rhs		// rhs-Z (?ȊO)
						
					} elsif and(nowData == BinOp_Which, peek(rhs) == '{') {
						Decode_UnBlock rhs		// rhs-Z (?); ( ?: ȂArhs[0]  :  EnParen ̂ '(' ̂͂ )
						
					} elsif and( nowData == BinOp_Pair, cnt + 1 < lenQueue, Queue_peek( inQueue(0), cnt + 1 ) == BinOp_Which, Queue_peek( inQueue(1), cnt + 1 ) == Valtype_OpBin ) {
						Decode_UnBlock lhs		// ?:  then-, else-Z
						Decode_UnBlock rhs
					}
					
					if ( nowData == BinOp_Lambda && lhs == STR_OMISSION ) {
						tmp = EnParen(DecodeOp_Bin(nowData) + " " + rhs)
					} else {
						tmp = EnParen( lhs + " " + DecodeOp_Bin(nowData) + " " + rhs )
					}
				}
				
				PushToStack stkDec, tmp, Valtype_Decoded
				swbreak
				
			case Valtype_OpPoly:
				if ( Stack_peek(stkDec(0)) == STR_OMISSION ) {
					repeat 2 : Stack_remove stkDec(cnt) : loop		// Ō̗vf omission => 
					nowData --
				}
				tmp = PopAsListDecodedByCount( stkDec, "(", ")", abs(nowData) )
				PushToStack stkDec, tmp, Valtype_Decoded
				swbreak
				
			default:
				logmes "[Error] when 񉻒 { [" + cnt + "], nowData: " + nowData + ", nowType: " + nowType + " }"
				assert
		swend
		
	loop
	
	// G[
	if ( stt_error ) {
		resVt = Valtype_Error
		
	} elsif ( Stack_empty(stkDec(0)) ) {
		result = ""
		resVt  = Valtype_Decoded
		
	// ʂԂ
	} else {
		result = PopAsDecoded( stkDec )
	}
	
	foreach stkDec : Stack_delete stkDec(cnt) : loop
	
	return result
	
		#undef NextLine
		#undef EnParen
	
//------------------------------------------------
// ̑O { } 
//------------------------------------------------
#deffunc Decode_UnBlock@mod_StrCalc_decode var self,  local tmp, local cntTabs
;	dbgout "unblock: " + self
	
	if ( peek(self, 1) == ' ' ) {		// Ȃ
		self = strmid( self, 2, strlen(self) - 2 * 2 )		// O ["{ ", " }"] 
		
	} else {
		// ɉs܂܂Ȃ => SĂ̎
		tmp = strmid( self, 4, strlen(self) - (4 + 3) )		// O ["{\n\t", "\n}"]  (g)
		if ( instr(tmp, 0, "\n\t") < 0 ) {
			repeat
				if ( peek(tmp, cnt) == '\t' ) { cntTabs ++ } else { break }
			loop
			getstr self, tmp, cntTabs						// ^uĖ{̂
			
		// s܂ => O { }  ( ) ɒu邾
		} else {
			self = "(" + strmid(self, 1, strlen(self) - 2) + ")"
		}
	}
	
;	dbgout "unblock-ed: " + self
	return
	
//##########################################################
//        X^bN̒lo
//##########################################################
//------------------------------------------------
// pop as decoded
//------------------------------------------------
#defcfunc PopAsDecoded@mod_StrCalc_decode array stkDec,  local result, local resVt
	
	result = Stack_pop( stkDec(0) )
	resVt  = Stack_pop( stkDec(1) )
	
	assert ( resVt == Valtype_Decoded )
	
	return result
	
//------------------------------------------------
// pop as list decoded
// 
// @ Mark: TkType_ArrayL o܂ŁAXgoA
// @	t ", " ŌqŁAʂŊāAԂB
//------------------------------------------------
#defcfunc PopAsListDecoded@mod_StrCalc_decode array stkDec, str lhsBracket, str rhsBracket,  \
	local arglist, local cntArgs, local list
	
	repeat
		if and( Stack_peek(stkDec(1)) == Valtype_Mark, Stack_peek(stkDec(0)) == TkType_ArrayL ) {
			cntArgs = cnt
			repeat 2 : Stack_remove stkDec(cnt) : loop		// I菜 (I͊ʂɈ˂炸)
			break	// I
		}
		
		list(cnt) = PopAsDecoded( stkDec )
	loop
	ArrayJoinReversed arglist, list, ", ", cntArgs
	
	return lhsBracket + which(cntArgs < 2, arglist, " " + arglist + " ") + rhsBracket
	
//------------------------------------------------
// pop as list decoded (by count)
// 
// @ w荀̃XgoA", " ŌqŁAʂŊĕԂB
//------------------------------------------------
#defcfunc PopAsListDecodedByCount@mod_StrCalc_decode array stkDec, str lhsBracket, str rhsBracket, int cntArgs,  \
	local arglist, local argc, local list
	
	repeat cntArgs
		list(cnt) = PopAsDecoded( stkDec )
	loop
	ArrayJoinReversed arglist, list, ", ", cntArgs
	if ( cntArgs == 1 ) { arglist += "," }
	
	return lhsBracket + which(cntArgs, arglist, " " + arglist + " ") + rhsBracket
	
//------------------------------------------------
// ztɘA
//------------------------------------------------
#deffunc ArrayJoinReversed@mod_StrCalc_decode var result, array list, str delimiter, int len
	if ( len <= 0 ) { result = "" : return }
	result = str( list(len - 1) )
	repeat len - 1, 1
		result += delimiter + list((len - 1) - cnt)
	loop
	return
	
#global

#endif
